=== debian/changelog ===
libfec (1.0+20161003-4) unstable; urgency=medium

  * Disable more power-specific code.
  * Make i386-specific symbols any-i386.

 -- Christoph Berg <myon@debian.org>  Fri, 24 Jan 2020 10:01:56 +0100

libfec (1.0+20161003-3) unstable; urgency=medium

  * Disable altivec code on power, it doesn't compile.
  * Add i386-specific symbols. (On amd64, generic code is used.)
  * Add build flags to i386-specific compiler commands.
  * dpkg-gensymbols: Do strict symbols checking.

 -- Christoph Berg <myon@debian.org>  Thu, 23 Jan 2020 20:23:50 +0100

libfec (1.0+20161003-2) unstable; urgency=medium

  * Set hamradio team as Maintainer.
  * Add watch file.
  * Fix altivec compiler flag on power.
  * Add build flags to all compiler commands.

 -- Christoph Berg <myon@debian.org>  Mon, 20 Jan 2020 11:16:32 +0100

libfec (1.0+20161003-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Sat, 04 Jan 2020 13:06:15 +0100
