=== debian/control ===
Source: libfec
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
Standards-Version: 4.5.0
Section: hamradio
Homepage: https://github.com/quiet/libfec
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libfec
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libfec.git

Package: libfec-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfec0 (= ${binary:Version}),
 ${misc:Depends},
Description: forward error correction (FEC) algorithms - header files
 This package provides a set of functions that implement several popular
 forward error correction (FEC) algorithms and several low-level routines
 useful in modems implemented with digital signal processing (DSP).
 .
 The following routines are provided:
  1. Viterbi decoders for the following convolutional codes:
   r=1/2 k=7 ("Voyager" code, now a widely used industry standard)
   r=1/2 k=9 (Used on the IS-95 CDMA forward link)
   r=1/6 k=15 ("Cassini" code, used by several NASA/JPL deep space missions)
  2. Reed-Solomon encoders and decoders for any user-specified code.
  3. Optimized encoder and decoder for the CCSDS-standard (255,223)
   Reed-Solomon code, with and without the CCSDS-standard "dual basis" symbol
   representation.
  4. Compute dot product between a 16-bit buffer and a set of 16-bit
   coefficients. This is the basic DSP primitive for digital filtering and
   correlation.
  4. Compute sum of squares of a buffer of 16-bit signed integers. This is
   useful in DSP for finding the total energy in a signal.
  5. Find peak value in a buffer of 16-bit signed integers, useful for
   scaling a signal to prevent overflow.
 .
 This package automatically makes use of various SIMD (Single Instruction
 stream, Multiple Data stream) instruction sets, when available: MMX, SSE and
 SSE2 on the IA-32 (Intel) architecture, and Altivec on the PowerPC G4 and G5
 used by Power Macintoshes.

Package: libfec0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: forward error correction (FEC) algorithms
 This package provides a set of functions that implement several popular
 forward error correction (FEC) algorithms and several low-level routines
 useful in modems implemented with digital signal processing (DSP).
 .
 The following routines are provided:
  1. Viterbi decoders for the following convolutional codes:
   r=1/2 k=7 ("Voyager" code, now a widely used industry standard)
   r=1/2 k=9 (Used on the IS-95 CDMA forward link)
   r=1/6 k=15 ("Cassini" code, used by several NASA/JPL deep space missions)
  2. Reed-Solomon encoders and decoders for any user-specified code.
  3. Optimized encoder and decoder for the CCSDS-standard (255,223)
   Reed-Solomon code, with and without the CCSDS-standard "dual basis" symbol
   representation.
  4. Compute dot product between a 16-bit buffer and a set of 16-bit
   coefficients. This is the basic DSP primitive for digital filtering and
   correlation.
  4. Compute sum of squares of a buffer of 16-bit signed integers. This is
   useful in DSP for finding the total energy in a signal.
  5. Find peak value in a buffer of 16-bit signed integers, useful for
   scaling a signal to prevent overflow.
 .
 This package automatically makes use of various SIMD (Single Instruction
 stream, Multiple Data stream) instruction sets, when available: MMX, SSE and
 SSE2 on the IA-32 (Intel) architecture, and Altivec on the PowerPC G4 and G5
 used by Power Macintoshes.
