=== debian/watch ===
version=4
opts="dversionmangle=s/\+.*//" \
https://github.com/quiet/libfec/releases .*/([0-9].*).tar.gz
