## libfec 1.0-26-gc5d935f

=== debian/changelog ===
libfec (1.0-26-gc5d935f-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Switch upstream to https://github.com/fblomqvi/libfec.
  * DH 13 and B-D on dh-exec.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Christoph Berg <myon@debian.org>  Fri, 04 Mar 2022 09:29:13 +0100
