=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
 Uploaders:
  Christoph Berg <myon@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
-Standards-Version: 4.5.0
+ debhelper-compat (= 13),
+ dh-exec,
+Standards-Version: 4.6.0
 Section: hamradio
-Homepage: https://github.com/quiet/libfec
+Homepage: https://github.com/fblomqvi/libfec
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libfec
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libfec.git
