=== debian/watch ===
version=4
opts="dversionmangle=s/-.*//" \
https://github.com/fblomqvi/libfec/tags .*/([0-9].*).tar.gz
